#include "csp-scope.hpp"
#include "csp-object.hpp"
#include "csp-symtable.hpp"

namespace CSP {

Scope::Scope() : outer(0) {
}
Scope::Scope(Scope* outer_param) : outer(outer_param) {
}

// accessors
bool Scope::lookup(const std::string& name,
      ProcessDefinitionPtr& process) const {
   ProcMap::const_iterator it = processes.find(name);
   if (it == processes.end()) {
      if (outer) {
	 return outer->lookup(name, process);
      } else {
	 return false;
      }
   } else {
      process = it->second;
      return true;
   }
}

Scope* Scope::get_outer() const {
   return outer;
}

// mutators
bool Scope::insert(const ProcessDefinitionPtr& process) {
   std::pair<ProcMap::iterator, bool> result =
      processes.insert(ProcMap::value_type(process->get_name(),
	 process));
   return result.second;
}

} // namespace CSP
