#ifndef CSP_SYMTABLE_H
#define CSP_SYMTABLE_H

#include <cassert>
#include <string>
#include <map>
#include <list>
#include <iostream>
#include <cstdlib>
#include "csp-types.hpp"

namespace CSP {

   class SymTable {
      private:
	 Scope* scope;
	 std::list<ProcessReferencePtr> unresolved;

      public:
	 // constructors
	 SymTable();

	 // accessors
	 bool lookup(const std::string name,
	       ProcessPtr& process) const;

	 // mutators
	 void open();
	 void close();
	 bool insert(const ProcessDefinitionPtr& process);
	 void add_unresolved(ProcessReferencePtr pref);
   };

} // namespace CSP

#endif
